--k
--require "ball"
require "player"
require "menu"
require "TLbind"
require "TLbind"
require "pauseMenu"


function love.load()
    TLbind,control = love.filesystem.load("TLbind.lua")()
	
	
	 
	 
	 --this is the font for the game 
      medium = love.graphics.newFont(45)
	  
        -----Store the new world in a variable such as "world"
	world = love.physics.newWorld(0, 0, true)  --Gravity is being set to 0 in the x direction and 0 in the y direction.
		 
	    ------Background-- color------
	love.graphics.setBackgroundColor (0, 0, 0, 0)

	gameState = "menu"

	     -----MenuButtons----
	menuButton_spawn(350, 200, "Start", "start") 
    menuButton_spawn(350, 250, "Save", "save") 
    menuButton_spawn(350, 300, "Options", "options") 
	menuButton_spawn(350, 350, "Credit", "credit") 
	menuButton_spawn(350, 400, "Quit", "quit") 
 

              ---pauseMenu----
	pauseMenu_spawn(350, 200, "ReStart", "restart") 
    pauseMenu_spawn(350, 250, "Save", "save") 
    pauseMenu_spawn(350, 300, "Options", "options") 
	pauseMenu_spawn(350, 400, "Quit", "quit")
		  
	
	    
			

		----------- the player's  ---------
	player = {}
		  player.body = love.physics.newBody(world, 200, 550, "dynamic")
		  player.body:setMass(100) -- make it pretty light
		  player.shape = love.physics.newRectangleShape(0, 0, 30, 15)
		  player.fixture = love.physics.newFixture(player.body, player.shape, 2) 
		  player.fixture:setRestitution(0.4)                                -- make it bouncy
          player.controlOptions, player.control = love.filesystem.load("TLbind.lua")()

				---------walls----of the game-----

	objects = {}	

	objects.static = {}

			objects.static.s = love.graphics.getWidth()
			objects.static.s = love.graphics.getHeight()
			objects.static.b = love.physics.newBody(world, 800/2,590, "static") -- "static" makes it not move
			objects.static.s = love.physics.newRectangleShape(790,20)         -- set size to 790,5 (x,y)
			objects.static.f = love.physics.newFixture(objects.static.b, objects.static.s)
			objects.static.f:setUserData("bottomWall")
  
	objects.static2 = {}
			objects.static2.s = love.graphics.getWidth()
			objects.static2.s = love.graphics.getHeight()
			objects.static2.b = love.physics.newBody(world, 800/2,10, "static") -- "static" makes it not move
			objects.static2.s = love.physics.newRectangleShape(790,5)         -- set size to 790,5 (x,y)
			objects.static2.f = love.physics.newFixture(objects.static2.b, objects.static2.s)
			objects.static2.f:setUserData("topWall")

	objects.staticL = {}
			objects.staticL.s = love.graphics.getWidth()
			objects.staticL.s = love.graphics.getHeight()
			objects.staticL.b = love.physics.newBody(world, 10,590/2, "static") -- "static" makes it not move
			objects.staticL.s = love.physics.newRectangleShape(5,570)         -- set size to 5,570 (x,y)
			objects.staticL.f = love.physics.newFixture(objects.staticL.b, objects.staticL.s)
			objects.staticL.f:setUserData("leftWall")

	objects.staticR = {}
			objects.staticR.s = love.graphics.getWidth()
			objects.staticR.s = love.graphics.getHeight()
			objects.staticR.b = love.physics.newBody(world, 795,599/2, "static") -- "static" makes it not move
			objects.staticR.s = love.physics.newRectangleShape(5,570)         -- set size to 5,570 (x,y)
			objects.staticR.f = love.physics.newFixture(objects.staticR.b, objects.staticR.s)
			objects.staticR.f:setUserData("rightWall")
			


			
		
		
end

function love.update(dt)

	if gameState == "playing" then 
	--Never forget to update your world every frame.
        world:update(dt)
		player_update(dt)
		--ball_update(dt)
        TLbind:update(dt)
	player.controlOptions:update(dt)


	end	
	
	if gameState == "playing" and love.keyboard.isDown("p") then 

	 pauseMenu_spawn()
	end 
	
   end
   






function love.draw()
   if gameState == "menu" then 
		menuButton_draw()
   end
   
   
	 if gameState == "playing" then
	 
		   player_draw()

			--ball_draw()

			
			love.graphics.setColor(255, 255, 255, 255) --colors for time/life
			love.graphics.print("Time/Life: ", 41,585, 0, 1, 1) -- displaying time/life
			
		 ------------walls-------------
		  love.graphics.setColor( 40, 215, 198, 255 ) --color of the bottomWall
		 love.graphics.polygon("line", objects.static.b:getWorldPoints(objects.static.s:getPoints()))
		 
		  love.graphics.setColor( 100, 15, 198, 255 )--color of the topWall
		 love.graphics.polygon("fill", objects.static2.b:getWorldPoints(objects.static2.s:getPoints()))

		  love.graphics.setColor( 109, 15, 98, 255 )--color of the leftWall
		 love.graphics.polygon("fill", objects.staticL.b:getWorldPoints(objects.staticL.s:getPoints()))

		  love.graphics.setColor( 170, 5, 18, 155 )--color of the rightWall
		 love.graphics.polygon("fill", objects.staticR.b:getWorldPoints(objects.staticR.s:getPoints()))
	 
	 end
	 if gameState == "playing" and love.keyboard.isDown("p") then 
	 pauseMenu_draw()
	 love.graphics.setColor( 40, 215, 198, 255 ) --color of the bottomWall
		 love.graphics.polygon("line",  pauseMenu.body:getWorldPoints(pauseMenu.shape:getPoints()))
	 
	 end
end


   
   
function love.focus(bool)
    -- this well soon be a pause function
 	if bool == true then
		print("in game")
	else
		print("out of game")
	end
	end



function love.keypressed(key, unicode)

	 print(key, x, y, unicode)

end
function love.keyreleased(key, x, y, unicode)

	 print(key, x, y, unicode)

end


function love.mousepressed ( x, y)
	print(key, x, y, unicode)
		 
	if gameState == "menu" then
		menuButton_click(x, y )
	end
	
	 if gameState == "playing" and love.keyboard.isDown("p") then 
		pauseMenu_click(x, y)
	end
end

function love.mousereleased (key, x, y)
	 print(key, x, y, unicode)

end

function love.quit()
--This will be printed to the console on quit
  print("Thanks for playing. Please play again soon!")
end


function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)

  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end



---------------------on sreen collison check--------------



